<!DOCTYPE html>
<html lang="en">

<head>
  <title>UserList</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- font -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Lato">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
</head>

<body onload="onPageLoading()">
  <div class="container-fluid">
    <h2 class="text-center">Danh sách người dùng đăng ký</h2>
    <table id="user-table" class="table table-bordered table-striped table-hover">
      <thead>
        <tr>
          <th>Mã người dùng</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Country</th>
          <th>Subject</th>
          <th>Customer Type</th>
          <th>Register Status</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>

      </tbody>
    </table>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-register-java-api/users";
    const gEND_ROW_TABLE = -1;
    // hằng số số thứ tự các cột
    const gCOLUMN_USER_ID = 0;
    const gCOLUMN_FIRSTNAME = 1;
    const gCOLUMN_LASTNAME = 2;
    const gCOLUMN_COUNTRY = 3;
    const gCOLUMN_SUBJECT = 4;
    const gCOLUMN_CUSTOMER_TYPE = 5;
    const gCOLUMN_REGISTER_STATUS = 6;
    const gCOLUMN_ACTION = 7;
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */


    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // hàm xử lý sự kiện loading
    function onPageLoading() {
      //B1
      //B2
      //B3: goi Api
      var vXmlHttp = new XMLHttpRequest();
      callApiGetUserList(vXmlHttp);
      //B4: Hien thi du lieu len bang
      showUserListToTable(vXmlHttp);
    }

    function onBtnChiTietClick(paramDetailButton) {
      // thu thập dữ liệu
      var vId = paramDetailButton.dataset.userid;
      var vFirstname = paramDetailButton.dataset.firstname;
      var vLastname = paramDetailButton.dataset.lastname;
      var vCountry = paramDetailButton.getAttribute("data-country");
      var vSubject = paramDetailButton.getAttribute("data-subject");
      var vCustomerType = paramDetailButton.getAttribute("data-customertype");
      var vRegisterStatus = paramDetailButton.getAttribute("data-registerstatus");
      // gọi và truyền data qua form Detail
      const vDETAIL_FORM_URL = "userDetail.html"
      var vUrlSiteToOpen = vDETAIL_FORM_URL +
        "?id=" + vId +
        "&firstname=" + vFirstname +
        "&lastname=" + vLastname +
        "&country=" + vCountry +
        "&subject=" + vSubject +
        "&customerType=" + vCustomerType +
        "&registerStatus=" + vRegisterStatus;
      window.location.href = vUrlSiteToOpen;
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function callApiGetUserList(paramXmlHttp) {
      paramXmlHttp.open("GET", gBASE_URL, true);
      paramXmlHttp.send();
    }

    function showUserListToTable(paramXmlHttp) {
      paramXmlHttp.onreadystatechange = function () {
        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
          console.log("responseText = " + paramXmlHttp.responseText);  //đây là responses text bạn có thể  phân tích 
          // code xử lý response ở đây
          var vUserListResponse = JSON.parse(paramXmlHttp.responseText); //chuyển responseText sang obj
          /*thêm code xử lý response*/
          var vTable = document.getElementById("user-table");
          var vTableBody = vTable.getElementsByTagName("tbody")[0]; //lấy tagname tbody vì nếu trỏ vào table cũng được nhưng nó sẽ vào thẻ thead

          for (var bIndex = 0; bIndex < vUserListResponse.length; bIndex++) {
            var vUser = vUserListResponse[bIndex]; //gán 1 user obj vào 1 biến user cho dễ sử dụng
            // tạo dòng mưới cho bẳng và ghi vào các giá trị 
            var row = vTableBody.insertRow(gEND_ROW_TABLE);

            var vCellUserId = row.insertCell(gCOLUMN_USER_ID);
            var vCellFirstname = row.insertCell(gCOLUMN_FIRSTNAME);
            var vCellLastname = row.insertCell(gCOLUMN_LASTNAME);
            var vCellCountry = row.insertCell(gCOLUMN_COUNTRY);
            var vCellSubject = row.insertCell(gCOLUMN_SUBJECT);
            var vCellCustomerType = row.insertCell(gCOLUMN_CUSTOMER_TYPE);
            var vCellRegisterStatus = row.insertCell(gCOLUMN_REGISTER_STATUS);
            var vCellAction = row.insertCell(gCOLUMN_ACTION);

            vCellUserId.innerHTML = vUser.id;
            vCellFirstname.innerHTML = vUser.firstname;
            vCellLastname.innerHTML = vUser.lastname;
            vCellCountry.innerHTML = vUser.country;
            vCellSubject.innerHTML = vUser.subject;
            vCellCustomerType.innerHTML = vUser.customerType;
            vCellRegisterStatus.innerHTML = vUser.registerStatus;
            //vCellAction.innerHTML = "<button class = 'btn btn-info' onclick = 'onBtnChiTietClick(this)' data-userid =" + vUser.userId + ">Chi tiết</button>";
            var vButtonDetail = document.createElement("button");
            vButtonDetail.innerHTML = "Chi tiết";
            vButtonDetail.className = 'btn btn-info info-user'; //kiểu button bootstrap và "info-user" là class để truy cập button sau này
            vButtonDetail.setAttribute("data-userid", vUser.id);
            vButtonDetail.setAttribute("data-firstname", vUser.firstname);
            vButtonDetail.setAttribute("data-lastname", vUser.lastname);
            vButtonDetail.setAttribute("data-country", vUser.country);
            vButtonDetail.setAttribute("data-subject", vUser.subject);
            vButtonDetail.setAttribute("data-customertype", vUser.customerType);
            vButtonDetail.setAttribute("data-registerstatus", vUser.registerStatus);
            //vButtonDetail.setAttribute("onclick", 'onBtnChiTietClick(this)');
            // add listener cho event handler (event click chính là onClick)
            // truy xuất tất cả các nút detail qua className 
            var vDetailButtons = document.getElementsByClassName("info-user");
            for (var bI = 0; bI < vDetailButtons.length; bI++) {
              vDetailButtons[bI].addEventListener('click', function () {
                onBtnChiTietClick(this);
              });
            }
            vCellAction.appendChild(vButtonDetail);
          }
        }
      };
    }
  </script>

</body>

</html>